print("Welcome to the maze generator");

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*								`				Constants and globals
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

var YES="1";
var NO="0";
var LEFT="L";
var UP="U";
var RIGHT="R";
var DOWN="D";
var FRAME_WIDTH=12;
var FRAME_HEIGHT=12;
var BUTTON_WIDTH=100;
var BUTTON_HEIGHT=28;

var maze=null;
var mazeEndAddress=null;
var mazeStartAddress=null;
var mazeTraversed=null;
var mazeCursor=null;
var mazeTileSize=null;
var showBasicMaze=null;
var showExplored=null;
var showToolTip=null;
var mazeLastCell=null;
var mazeContextMenu=null;

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														General
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function fPushListElement( element ){
	this.list[this.list.length]=element;		
}
function fPopListElement(){
	if ( this.list.length==0 ) return null;
	var last=this.list.length-1;
	var result=this.list[last];
	this.list.length=last;
	return result;
}
function fGetListElement(index){
	if ( index<0||index>=this.list.length ) return null;
	return this.list[index];
}
function fAppendList( elementList ){
	for ( var i=0; i<elementList.list.length; ++i ){
		this.list[this.list.length]=elementList.list[i];
	}
}

function fSetButtonImage( image ){
 image.height=this.height;
 image.width=this.width;
 image.hRegistrationPoint=this.hRegistrationPoint;
 image.vRegistrationPoint=this.hRegistrationPoint;
 this.buttonImage=image;
 this.alignButtonImage();
}
function fAlignButtonImage(){
 this.buttonImage.hOffset=this.hOffset;
 this.buttonImage.vOffset=this.vOffset;
 this.buttonImage.opacity=this.opacity;
 this.buttonImage.orderAbove( this );
}
Image.prototype.setButtonImage=fSetButtonImage;
Image.prototype.alignButtonImage=fAlignButtonImage;

function fSetButtonText( buttonText ){
 buttonText.style.fontFamily="sans-serif";;
 buttonText.style.fontSize="14px";
 buttonText.style.fontStyle="normal";
 buttonText.style.fontWeight="bold";
 buttonText.style.textAlign="center";
 buttonText.style.opacity==1;
 this.buttonText=buttonText;
 this.alignButtonText();
}
function fAlignButtonText(){
 this.buttonText.hOffset=this.hOffset-Math.floor(this.buttonText.width/2);
 this.buttonText.vOffset=this.vOffset+Math.floor((this.height-this.buttonText.height)/2)-2;
 this.buttonText.style.opacity=(this.opacity==0)?0:1;
 this.buttonText.orderAbove( this );
}
Image.prototype.setButtonText=fSetButtonText;
Image.prototype.alignButtonText=fAlignButtonText;



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														Address
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function fToStringAddress(){
	return "Address("+this.row+","+this.column+")";
}
function Address( row,column ){
	this.row=row;
	this.column=column;
}
Address.prototype.toString=fToStringAddress;
// end object Address()


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														AddressList
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function fToStringAddressList(){
	var result="AddressList(";
	var size=this.list.length;
	for ( var i=0; i<this.list.length; ++i ){
		if ( i>0 ) result=result+",";
		result=result+"\t"+i+"="+this.getAddress( i );
	}
	return result+"\t)";
}
function AddressList(){
	this.list=new Array();
}
AddressList.prototype.pushAddress=fPushListElement;
AddressList.prototype.popAddress=fPopListElement;
AddressList.prototype.getAddress=fGetListElement;
AddressList.prototype.appendAddressList=fAppendList;
AddressList.prototype.toString=fToStringAddressList;
 // end AddressList()


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														Cell
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function fToStringCell(){
	var result="Cell(";
	result=result+"address="+this.address;
	result=result+",isAvailable="+this.getAvailableImageTags();
	result=result+",isUsed="+this.getUsedImageTags();
	result=result+",isOptimal="+this.getOptimalImageTags();
	result=result+",distance="+this.distance;
	return result+")";
}
function fMoveLeftCell(){
	var moveCell=this.cells[0];
	if ( moveCell==null ) return this;
	this.isUsed[0]=YES;
	moveCell.isUsed[2]=YES;
	moveCell.arriveCell();
	return moveCell;
}
function fMoveUpCell(){
	var moveCell=this.cells[1];
	if ( moveCell==null ) return this;
	this.isUsed[1]=YES;
	moveCell.isUsed[3]=YES;
	moveCell.arriveCell();
	return moveCell;
}
function fMoveRightCell(){
	var moveCell=this.cells[2];
	if ( moveCell==null ) return this;
	this.isUsed[2]=YES;
	moveCell.isUsed[0]=YES;
	moveCell.arriveCell();
	return moveCell;
}
function fMoveDownCell(){
	var moveCell=this.cells[3];
	if ( moveCell==null ) return this;
	this.isUsed[3]=YES;
	moveCell.isUsed[1]=YES;
	moveCell.arriveCell();
	return moveCell;
}
function fArriveCell(){
	if ( mazeLastCell!=null&&showExplored ) mazeLastCell.setUsedImageSrc();
	mazeTraversed.pushAddress( this.address );
	mazeCursor.hOffset=this.address.column*mazeTileSize;
	mazeCursor.vOffset=this.address.row*mazeTileSize;
	if ( !showBasicMaze ) this.setAvailableImageSrc( true );
	if ( showExplored ) this.setUsedImageSrc();
	if ( mazeLastCell!=null&&!showBasicMaze ) mazeLastCell.setAvailableImageSrc( false );
	var isDone=( this.address.row==mazeEndAddress.row&&this.address.column==mazeEndAddress.column );
	doMoveLeft.opacity=(this.isAvailable[0]==YES&&!isDone)?255:0;
	doMoveLeft.alignButtonImage();
	doMoveUp.opacity=(this.isAvailable[1]==YES&&!isDone)?255:0;
	doMoveUp.alignButtonImage();
	doMoveRight.opacity=(this.isAvailable[2]==YES&&!isDone)?255:0;
	doMoveRight.alignButtonImage();
	doMoveDown.opacity=(this.isAvailable[3]==YES&&!isDone)?255:0;
	doMoveDown.alignButtonImage();
	mazeLastCell=this;
	if ( isDone ) {
		doSolution.opacity=0;
		doSolution.alignButtonText();
		for ( var row=0; row<maze.length; ++row ) {
			for ( var column=0; column<maze[row].length; ++column ) {
				if ( !showBasicMaze ) maze[row][column].setAvailableImageSrc( true );
				if ( !showExplored ) maze[row][column].setUsedImageSrc();
			}
		}
		showOptimalTrack();
	}
}
function fGetFromCell(){
	if ( this.distance>0 ) {
		if ( this.leftIsAvailable()&&this.cells[0].distance<this.distance ) return this.cells[0];
		if ( this.upIsAvailable()&&this.cells[1].distance<this.distance ) return this.cells[1];
		if ( this.rightIsAvailable()&&this.cells[2].distance<this.distance ) return this.cells[2];
		if ( this.downIsAvailable()&&this.cells[3].distance<this.distance ) return this.cells[3];
	}
	return null;
}
function fGetLeftCell(){
	return this.cells[0];
}
function fGetUpCell(){
	return this.cells[1];
}
function fGetRightCell(){
	return this.cells[2];
}
function fGetDownCell(){
	return this.cells[3];
}
function fGetAvailableImageTags(){
	return this.isAvailable[0]+this.isAvailable[1]+this.isAvailable[2]+this.isAvailable[3];
}
function fSetAvailableImageSrc( show ){
	if ( show ) {
		this.tiles[1].src="Resources/Track"+this.getAvailableImageTags()+"standard30.png";
	} else {
		this.tiles[1].src="Resources/Track0000standard30.png";
	}
}
function fLeftIsAvailable(){
	return this.isAvailable[0]==YES;
}
function fUpIsAvailable(){
	return this.isAvailable[1]==YES;
}
function fRightIsAvailable(){
	return this.isAvailable[2]==YES;
}
function fDownIsAvailable(){
	return this.isAvailable[3]==YES;
}
function fGetOptimalImageTags(){
	return this.isOptimal[0]+this.isOptimal[1]+this.isOptimal[2]+this.isOptimal[3];
}
function fSetOptimalImageSrc(){
	this.tiles[3].src="Resources/Track"+this.getOptimalImageTags()+"solution30.png";
}
function fSetEndsImageSrc(){
	this.tiles[0].src="Resources/TrackEnds30.png";
}
function fGetUsedImageTags(){
	return this.isUsed[0]+this.isUsed[1]+this.isUsed[2]+this.isUsed[3];
}
function fSetUsedImageSrc(){
	this.tiles[2].src="Resources/Track"+this.getUsedImageTags()+"discovered30.png";
}
function fLeftIsUsed(){
	return this.isUsed[0]==YES;
}
function fUpIsUsed(){
	return this.isUsed[1]==YES;
}
function fRightIsUsed(){
	return this.isUsed[2]==YES;
}
function fDownIsUsed(){
	return this.isUsed[3]==YES;
}
function Cell(row,column){
	this.address=new Address(row,column);
	this.tiles=new Array(4);
	this.tiles[0]=new Image();
	this.tiles[0].src="Resources/TrackBack30.png";
	this.tiles[0].height=mazeTileSize;
	this.tiles[0].width=mazeTileSize;
	this.tiles[0].hOffset=column*mazeTileSize;
	this.tiles[0].vOffset=row*mazeTileSize;
	this.tiles[1]=new Image();
	this.tiles[1].src="Resources/Track0000standard30.png";
	this.tiles[1].height=mazeTileSize;
	this.tiles[1].width=mazeTileSize;
	this.tiles[1].hOffset=column*mazeTileSize;
	this.tiles[1].vOffset=row*mazeTileSize;
	this.tiles[2]=new Image();
	this.tiles[2].src="Resources/Track0000discovered30.png";
	this.tiles[2].height=mazeTileSize;
	this.tiles[2].width=mazeTileSize;
	this.tiles[2].hOffset=column*mazeTileSize;
	this.tiles[2].vOffset=row*mazeTileSize;
	this.tiles[3]=new Image();
	this.tiles[3].src="Resources/Track0000solution30.png";
	this.tiles[3].height=mazeTileSize;
	this.tiles[3].width=mazeTileSize;
	this.tiles[3].hOffset=column*mazeTileSize;
	this.tiles[3].vOffset=row*mazeTileSize;
	this.tiles[3].tracking="rectangle";
	this.tiles[3].onMouseUp="cellGoTo("+row+","+column+");";
	this.cells=[null,null,null,null];
	this.isAvailable=[NO,NO,NO,NO];
	this.isUsed=[NO,NO,NO,NO];
	this.isOptimal=[NO,NO,NO,NO];
	this.toOptimalCell=null;
	this.toOptimalMove=null;
	this.distance=null;
	mazeWindow.appendChild( this.tiles[0] );
	mazeWindow.appendChild( this.tiles[1] );
	mazeWindow.appendChild( this.tiles[2] );
	mazeWindow.appendChild( this.tiles[3] );
}
Cell.prototype.toString=fToStringCell;
Cell.prototype.moveLeftCell=fMoveLeftCell;
Cell.prototype.moveUpCell=fMoveUpCell;
Cell.prototype.moveRightCell=fMoveRightCell;
Cell.prototype.moveDownCell=fMoveDownCell;
Cell.prototype.leftIsAvailable=fLeftIsAvailable;
Cell.prototype.upIsAvailable=fUpIsAvailable;
Cell.prototype.rightIsAvailable=fRightIsAvailable;
Cell.prototype.downIsAvailable=fDownIsAvailable;
Cell.prototype.arriveCell=fArriveCell;
Cell.prototype.getAvailableImageTags=fGetAvailableImageTags;
Cell.prototype.setAvailableImageSrc=fSetAvailableImageSrc;
Cell.prototype.setEndOfLine=fSetEndsImageSrc;
Cell.prototype.getOptimalImageTags=fGetOptimalImageTags;
Cell.prototype.setOptimalImageSrc=fSetOptimalImageSrc;
Cell.prototype.leftIsUsed=fLeftIsUsed;
Cell.prototype.upIsUsed=fUpIsUsed;
Cell.prototype.rightIsUsed=fRightIsUsed;
Cell.prototype.downIsUsed=fDownIsUsed;
Cell.prototype.getUsedImageTags=fGetUsedImageTags;
Cell.prototype.setUsedImageSrc=fSetUsedImageSrc;
Cell.prototype.getFromCell=fGetFromCell;
// end object Cell()


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														CellList 
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function fToStringCellList(){
	var result="CellList(";
	var size=this.list.length;
	for ( var i=0; i<size; ++i ){
		if ( i>0 ) result=result+",";
		result=result+"\t"+i+"="+this.getCell( i );
	}
	return result+"\t)";
}
function CellList(){
	this.list=new Array();
}
CellList.prototype.pushCell=fPushListElement;
CellList.prototype.popCell=fPopListElement;
CellList.prototype.getCell=fGetListElement;
CellList.prototype.appendCellList=fAppendList;
CellList.prototype.toString=fToStringCellList;
// end CellList()


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														cellGoTo
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function cellGoTo( row, column ){
	var address=mazeTraversed.list[mazeTraversed.list.length-1];
	if ( address.row==row&&address.column==column ) return;
	if ( address.row==mazeEndAddress.row&&address.column==mazeEndAddress.column ) return;
	var fromCell=maze[address.row][address.column];
	var intoCell=maze[row][column];
	if ( !showBasicMaze ) {
		if ( intoCell.isUsed[0]==NO&&intoCell.isUsed[1]==NO&&intoCell.isUsed[2]==NO&&intoCell.isUsed[3]==NO){
			alert( "You may not go directly to a location that you have not seen!","OK" );
			mainWindow.focus();
			return;
		}
	}
	var backCellList=new CellList();
	var moveCellList=new CellList();
	while ( !( fromCell.address.row==intoCell.address.row && fromCell.address.column==intoCell.address.column ) ){
		if ( fromCell.distance > intoCell.distance ) { // retreat on the from path to find conjunction
			fromCell=fromCell.getFromCell();
			backCellList.pushCell( fromCell );
		} else if ( fromCell.distance < intoCell.distance ) { // retreat on the into path to find conjunction
			moveCellList.pushCell( intoCell );
			intoCell=intoCell.getFromCell();
		} else { // retreat on both paths to find conjunction
			moveCellList.pushCell( intoCell );
			fromCell=fromCell.getFromCell();
			intoCell=intoCell.getFromCell();
			backCellList.pushCell( fromCell );
		}
	}
	if ( backCellList.list.length>0 ){
		var alertResponse=alert( "Backup "+backCellList.list.length+" moves?","Yes","No" );
		mainWindow.focus();
		if ( 2==alertResponse ) return;
	}
	// retreat
	if ( backCellList.list.length>0 ){
		for ( var i=0; i<backCellList.list.length; ++i ){
			fromCell=backCellList.list[i];
			fromCell.arriveCell();
		}
	}
	// advance
	for ( var i=moveCellList.list.length-1; i>=0; --i ){
		intoCell=moveCellList.list[i];
		if ( intoCell.address.row==fromCell.address.row&&intoCell.address.column<fromCell.address.column ){
			fromCell.moveLeftCell();
		} else if ( intoCell.address.row<fromCell.address.row&&intoCell.address.column==fromCell.address.column ){
			fromCell.moveUpCell();
		} else if ( intoCell.address.row==fromCell.address.row&&intoCell.address.column>fromCell.address.column ){
			fromCell.moveRightCell();
		} else if ( intoCell.address.row>fromCell.address.row&&intoCell.address.column==fromCell.address.column ){
			fromCell.moveDownCell();
		}
		fromCell=intoCell;
	}
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														parseKeyPress
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function parseKeyPress(){
	var key_string=system.event.keyString;
	var mod=system.event.modifiers;
	var key=system.event.key;
	var address=mazeTraversed.list[mazeTraversed.list.length-1];
	if ( address.row==mazeEndAddress.row&&address.column==mazeEndAddress.column ) return;
	switch ( key_string ){
		case "LeftArrow":
			var cell=maze[address.row][address.column];
			if ( cell.leftIsAvailable() ) cell.moveLeftCell();
			break;
		case "UpArrow":
			var cell=maze[address.row][address.column];
			if ( cell.upIsAvailable() ) cell.moveUpCell();
			break;
		case "RightArrow":
			var cell=maze[address.row][address.column];
			if ( cell.rightIsAvailable() ) cell.moveRightCell();
			break;
		case "DownArrow":
			var cell=maze[address.row][address.column];
			if ( cell.downIsAvailable() ) cell.moveDownCell();
			break;
		case "Escape":
			showOptimalTrack();
			break;
	}
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														fDoNewMazeMouseDown
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function fDoNewMazeMouseDown(){
	doNewMaze.rotation=180;
	doNewMaze.buttonText.hOffset++;
	doNewMaze.buttonText.vOffset++;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														fDoNewMazeMouseUp
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function fDoNewMazeMouseUp(){
	doNewMaze.rotation=0;
	doNewMaze.alignButtonText();
	initializeMaze();
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														fDoSolutionMouseDown
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function fDoSolutionMouseDown(){
	doSolution.rotation=180;
	doSolution.buttonText.hOffset++;
	doSolution.buttonText.vOffset++;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														fDoSolutionMouseUp
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function fDoSolutionMouseUp(){
	doSolution.rotation=0;
	doSolution.alignButtonText();
	showOptimalTrack();
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														fdoHelpMouseDown
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function fdoHelpMouseDown(){
	doHelp.rotation=180;
	doHelp.buttonText.hOffset++;
	doHelp.buttonText.vOffset++;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														fdoHelpMouseUp
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function fdoHelpMouseUp(){
	toggleHelpText();
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														fDoMoveLeftMouseDown
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function fDoMoveLeftMouseDown(){
	doMoveLeft.rotation=180;
	doMoveLeft.buttonImage.hOffset++;
	doMoveLeft.buttonImage.vOffset++;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														fDoMoveLeftMouseUp
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function fDoMoveLeftMouseUp(){
	doMoveLeft.rotation=0;
	doMoveLeft.alignButtonImage();
	var address=mazeTraversed.list[mazeTraversed.list.length-1];
	var cell=maze[address.row][address.column];
	if ( cell.leftIsAvailable() ) cell.moveLeftCell();
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														fDoMoveUpMouseDown
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function fDoMoveUpMouseDown(){
	doMoveUp.rotation=180;
	doMoveUp.buttonImage.hOffset++;
	doMoveUp.buttonImage.vOffset++;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														fDoMoveUpMouseDown
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function fDoMoveUpMouseUp(){
	doMoveUp.rotation=0;
	doMoveUp.alignButtonImage();
	var address=mazeTraversed.list[mazeTraversed.list.length-1];
	var cell=maze[address.row][address.column];
	if ( cell.upIsAvailable() ) cell.moveUpCell();
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														fDoMoveRightMouseDown
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function fDoMoveRightMouseDown(){
	doMoveRight.rotation=180;
	doMoveRight.buttonImage.hOffset++;
	doMoveRight.buttonImage.vOffset++;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														fDoMoveRightMouseUp
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function fDoMoveRightMouseUp(){
	doMoveRight.rotation=0;
	doMoveRight.alignButtonImage();
	var address=mazeTraversed.list[mazeTraversed.list.length-1];
	var cell=maze[address.row][address.column];
	if ( cell.rightIsAvailable() ) cell.moveRightCell();
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														fDoMoveDownMouseDown
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function fDoMoveDownMouseDown(){
	doMoveDown.rotation=180;
	doMoveDown.buttonImage.hOffset++;
	doMoveDown.buttonImage.vOffset++;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														fDoMoveUpMouseDown
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function fDoMoveDownMouseUp(){
	doMoveDown.rotation=0;
	doMoveDown.alignButtonImage();
	var address=mazeTraversed.list[mazeTraversed.list.length-1];
	var cell=maze[address.row][address.column];
	if ( cell.downIsAvailable() ) cell.moveDownCell();
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														toggleHelpText
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function toggleHelpText(){
	doHelp.rotation=0;
	if ( helpText.visible ){
		helpText.visible=false;
		doHelp.buttonText.data="?";
		mazeContextMenu[0].checked=false;
	} else {
		helpText.width=mazeWindow.width;
		helpText.height=mazeWindow.height;
		helpText.visible=true;
		doHelp.buttonText.data="X";
		mazeContextMenu[0].checked=true;
	}
	doHelp.alignButtonText();
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														Initial Setup
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function initializeMaze(){
	heartbeat.ticking="false";
	mazeTileSize=preferences.showTileSize.value;
	var maxRows=Math.floor( (screen.availHeight-52)/mazeTileSize );
	var minRows=Math.floor( 350/mazeTileSize );
	var maxColumns=Math.floor( (screen.availWidth-24)/mazeTileSize );
	var minColumns=Math.floor( 460/mazeTileSize );
	var rows=minRows+Math.floor((maxRows-minRows)*preferences.sizeWeight.value/100);
	var columns=minColumns+Math.floor((maxColumns-minColumns)*preferences.sizeWeight.value/100);
	var bendWeight=9-Math.floor(18*preferences.bendWeight.value/100); // -9 to +9
	var forkWeight=1+Math.floor(8*preferences.forkWeight.value/100); // 1-9
	showBasicMaze=(preferences.showBasicMaze.value==1);
	showExplored=(preferences.showExplored.value==1);
	showToolTip=(preferences.showToolTip.value==1);
	print("Initializing maze["+rows+"]["+columns+"]");
	mainWindow.visible=false;
	mainWindow.height=FRAME_HEIGHT+(rows*mazeTileSize)+BUTTON_HEIGHT+FRAME_HEIGHT;
	mainWindow.width=FRAME_WIDTH+(columns*mazeTileSize)+FRAME_WIDTH;
	
	mainFrameTL.vOffset=0;
	mainFrameTL.hOffset=0;
	mainFrameTL.height=FRAME_HEIGHT;
	mainFrameTL.width=FRAME_WIDTH;
	mainFrameTC.vOffset=0;
	mainFrameTC.hOffset=FRAME_WIDTH;
	mainFrameTC.height=FRAME_HEIGHT;
	mainFrameTC.width=(columns*mazeTileSize);
	mainFrameTR.vOffset=0;
	mainFrameTR.hOffset=FRAME_WIDTH+(columns*mazeTileSize);
	mainFrameTR.height=FRAME_HEIGHT;
	mainFrameTR.width=FRAME_WIDTH;
	mainFrameLC.vOffset=FRAME_HEIGHT;
	mainFrameLC.hOffset=0;
	mainFrameLC.height=(rows*mazeTileSize)+BUTTON_HEIGHT;
	mainFrameLC.width=FRAME_WIDTH;
	mainFrameCC.vOffset=FRAME_HEIGHT+(rows*mazeTileSize);
	mainFrameCC.hOffset=FRAME_WIDTH;
	mainFrameCC.height=BUTTON_HEIGHT;
	mainFrameCC.width=(columns*mazeTileSize);
	mainFrameRC.vOffset=FRAME_HEIGHT;
	mainFrameRC.hOffset=FRAME_WIDTH+(columns*mazeTileSize);
	mainFrameRC.height=(rows*mazeTileSize)+BUTTON_HEIGHT;
	mainFrameRC.width=FRAME_WIDTH;
	mainFrameBL.vOffset=FRAME_HEIGHT+(rows*mazeTileSize)+BUTTON_HEIGHT;
	mainFrameBL.hOffset=0;
	mainFrameBL.height=FRAME_HEIGHT;
	mainFrameBL.width=FRAME_WIDTH;
	mainFrameBC.vOffset=FRAME_HEIGHT+(rows*mazeTileSize)+BUTTON_HEIGHT;
	mainFrameBC.hOffset=FRAME_WIDTH;
	mainFrameBC.height=FRAME_HEIGHT;
	mainFrameBC.width=(columns*mazeTileSize);
	mainFrameBR.vOffset=FRAME_HEIGHT+(rows*mazeTileSize)+BUTTON_HEIGHT;
	mainFrameBR.hOffset=FRAME_WIDTH+(columns*mazeTileSize);
	mainFrameBR.height=FRAME_HEIGHT;
	mainFrameBR.width=FRAME_WIDTH;
	mazeWindow.vOffset=FRAME_HEIGHT;
	mazeWindow.hOffset=FRAME_WIDTH;
	mazeWindow.height=(rows*mazeTileSize);
	mazeWindow.width=(columns*mazeTileSize);
	maze=new Array(rows);
	for (var row=0; row<rows; ++row) {
		maze[row]=new Array(columns);
		for (var column=0; column<columns; ++column) {
			maze[row][column]=new Cell(row,column);
		}
	}
	
	mazeStartAddress=new Address(Math.floor(Math.random()*rows),0);
	var cell=maze[mazeStartAddress.row][mazeStartAddress.column];
	cell.setEndOfLine();
	cell.distance=0;
	mazeEndAddress=new Address(cell.address.row,cell.address.column);
	mazeEndAddress.distance=cell.distance;
	var buildList=new CellList();
	
	var lastRow=rows-1;
	var lastColumn=columns-1;
	var forkCount=forkWeight*forkWeight;
	while( cell!=null ){
		
		if ( forkCount==0 ) {
			buildList.pushCell( cell );
			for ( var i=0; i<buildList.list.length; ++i ) {
				var fork=buildList.list[i];
				if ( ((!fork.rightIsAvailable())&&(fork.address.column<lastColumn)&&(maze[fork.address.row][fork.address.column+1].distance==null)) 
					|| ((!fork.leftIsAvailable())&&(fork.address.column>0)&&(maze[fork.address.row][fork.address.column-1].distance==null)) 
					|| ((!fork.downIsAvailable())&&(fork.address.row<lastRow)&&(maze[fork.address.row+1][fork.address.column].distance==null)) 
					|| ((!fork.upIsAvailable())&&(fork.address.row>0)&&(maze[fork.address.row-1][fork.address.column].distance==null)) ){
					if ( fork.distance<cell.distance ) cell=fork;
				}
			}
			forkCount=forkWeight*forkWeight;
		} else --forkCount;
		
		var address=cell.address;
		var moves=new Array();
		if ( (!cell.rightIsAvailable())&&(address.column<lastColumn)&&(maze[address.row][address.column+1].distance==null) ){
			moves[moves.length]=RIGHT;
			if ( cell.leftIsAvailable() && bendWeight<0 ){
				for ( var i=0; i>bendWeight; --i ) moves[moves.length]=RIGHT;
			} else if ( !cell.leftIsAvailable() && bendWeight>0 ){
				for ( var i=0; i<bendWeight; ++i ) moves[moves.length]=RIGHT;
			}
		}
		if ( (!cell.leftIsAvailable())&&(address.column>0)&&(maze[address.row][address.column-1].distance==null) ){
			moves[moves.length]=LEFT;
			if ( cell.rightIsAvailable && bendWeight<0 ){
				for ( var i=0; i>bendWeight; --i ) moves[moves.length]=LEFT;
			} else if ( !cell.rightIsAvailable && bendWeight>0 ){
				for ( var i=0; i<bendWeight; ++i ) moves[moves.length]=LEFT;
			}
		}
		if ( (!cell.downIsAvailable())&&(address.row<lastRow)&&(maze[address.row+1][address.column].distance==null) ){
			moves[moves.length]=DOWN;
			if ( cell.upIsAvailable() && bendWeight<0 ){
				for ( var i=0; i>bendWeight; --i ) moves[moves.length]=DOWN;
			} else if ( !cell.upIsAvailable() && bendWeight>0 ){
				for ( var i=0; i<bendWeight; ++i ) moves[moves.length]=DOWN;
			}
		}
		if ( (!cell.upIsAvailable())&&(address.row>0)&&(maze[address.row-1][address.column].distance==null) ){
			moves[moves.length]=UP;
			if ( cell.downIsAvailable() && bendWeight<0 ){
				for ( var i=0; i>bendWeight; --i ) moves[moves.length]=UP;
			} else if ( !cell.downIsAvailable() && bendWeight>0 ){
				for ( var i=0; i<bendWeight; ++i ) moves[moves.length]=UP;
			}
		}
		if ( moves.length>0 ){
			var move=moves[Math.floor(Math.random()*moves.length)];
			switch ( move ){
				case RIGHT:
					buildList.pushCell( cell );
					var bindCell=maze[cell.address.row][cell.address.column+1];
					cell.cells[2]=bindCell;
					cell.isAvailable[2]=YES;
					bindCell.cells[0]=cell;
					bindCell.isAvailable[0]=YES;
					bindCell.distance=cell.distance+1;
					cell=bindCell;
					break;
				case LEFT:
					buildList.pushCell( cell );
					var bindCell=maze[cell.address.row][cell.address.column-1];
					cell.cells[0]=bindCell;
					cell.isAvailable[0]=YES;
					bindCell.cells[2]=cell;
					bindCell.isAvailable[2]=YES;
					bindCell.distance=cell.distance+1;
					cell=bindCell;
					break;
				case DOWN:
					buildList.pushCell( cell );
					var bindCell=maze[cell.address.row+1][cell.address.column];
					cell.cells[3]=bindCell;
					cell.isAvailable[3]=YES;
					bindCell.cells[1]=cell;
					bindCell.isAvailable[1]=YES;
					bindCell.distance=cell.distance+1;
					cell=bindCell;
					break;
				case UP:
					buildList.pushCell( cell );
					var bindCell=maze[cell.address.row-1][cell.address.column];
					cell.cells[1]=bindCell;
					cell.isAvailable[1]=YES;
					bindCell.cells[3]=cell;
					bindCell.isAvailable[3]=YES;
					bindCell.distance=cell.distance+1;
					cell=bindCell;
					break;
			}
			if ( mazeEndAddress.distance<cell.distance ){
				mazeEndAddress.row=cell.address.row;
				mazeEndAddress.column=cell.address.column;
				mazeEndAddress.distance=cell.distance;
			}
		} else {
			cell=buildList.popCell();
		}
	}
	for (var row=0; row<rows; ++row) {
		for (var column=0; column<columns; ++column) {
			maze[row][column].setAvailableImageSrc( showBasicMaze );
		}
	}

	cell=maze[mazeEndAddress.row][mazeEndAddress.column];
	cell.setEndOfLine();
	while ( cell.distance>0 ){
		if ( cell.leftIsAvailable()&&cell.cells[0].distance<cell.distance ){
			from=cell.cells[0];
			from.toOptimalCell=cell;
			from.toOptimalMove=RIGHT;
		} else if ( cell.upIsAvailable()&&cell.cells[1].distance<cell.distance ){
			from=cell.cells[1];
			from.toOptimalCell=cell;
			from.toOptimalMove=DOWN;
		} else if ( cell.rightIsAvailable()&&cell.cells[2].distance<cell.distance ){
			from=cell.cells[2];
			from.toOptimalCell=cell;
			from.toOptimalMove=LEFT;
		} else if ( cell.downIsAvailable()&&cell.cells[3].distance<cell.distance ){
			from=cell.cells[3];
			from.toOptimalCell=cell;
			from.toOptimalMove=UP;
		}
		cell=from;
	}

	mazeCursor=new Image();
	mazeCursor.src="Resources/TrackCursor30.png";
	mazeCursor.height=mazeTileSize;
	mazeCursor.width=mazeTileSize;
	mazeCursor.opacity=255;
	mazeWindow.appendChild( mazeCursor );

	doNewMaze.vOffset=FRAME_HEIGHT+(rows*mazeTileSize)+(0.5*BUTTON_HEIGHT);
	doNewMaze.hOffset=FRAME_WIDTH+(BUTTON_WIDTH/2);
	doNewMaze.height=BUTTON_HEIGHT;
	doNewMaze.width=BUTTON_WIDTH;
	doNewMaze.opacity=255;
	doNewMaze.alignButtonText();
	doSolution.vOffset=FRAME_HEIGHT+(rows*mazeTileSize)+(0.5*BUTTON_HEIGHT);
	doSolution.hOffset=FRAME_WIDTH+(1.5*BUTTON_WIDTH);
	doSolution.height=BUTTON_HEIGHT;
	doSolution.width=BUTTON_WIDTH;
	doSolution.opacity=255;
	doSolution.alignButtonText();
	doMoveLeft.vOffset=FRAME_HEIGHT+(rows*mazeTileSize)+(0.5*BUTTON_HEIGHT);
	doMoveLeft.hOffset=FRAME_WIDTH+(2.0*BUTTON_WIDTH)+(0.5*BUTTON_HEIGHT);
	doMoveLeft.height=BUTTON_HEIGHT;
	doMoveLeft.width=BUTTON_HEIGHT;
	doMoveLeft.opacity=0;
	doMoveLeft.alignButtonImage();
	doMoveUp.vOffset=FRAME_HEIGHT+(rows*mazeTileSize)+(0.5*BUTTON_HEIGHT);
	doMoveUp.hOffset=FRAME_WIDTH+(2.0*BUTTON_WIDTH)+(1.5*BUTTON_HEIGHT);
	doMoveUp.height=BUTTON_HEIGHT;
	doMoveUp.width=BUTTON_HEIGHT;
	doMoveUp.opacity=0;
	doMoveUp.alignButtonImage();
	doMoveRight.vOffset=FRAME_HEIGHT+(rows*mazeTileSize)+(0.5*BUTTON_HEIGHT);
	doMoveRight.hOffset=FRAME_WIDTH+(2.0*BUTTON_WIDTH)+(2.5*BUTTON_HEIGHT);
	doMoveRight.height=BUTTON_HEIGHT;
	doMoveRight.width=BUTTON_HEIGHT;
	doMoveRight.opacity=0;
	doMoveRight.alignButtonImage();
	doMoveDown.vOffset=FRAME_HEIGHT+(rows*mazeTileSize)+(0.5*BUTTON_HEIGHT);
	doMoveDown.hOffset=FRAME_WIDTH+(2.0*BUTTON_WIDTH)+(3.5*BUTTON_HEIGHT);
	doMoveDown.height=BUTTON_HEIGHT;
	doMoveDown.width=BUTTON_HEIGHT;
	doMoveDown.opacity=0;
	doMoveDown.alignButtonImage();
	doHelp.vOffset=FRAME_HEIGHT+(rows*mazeTileSize)+(0.5*BUTTON_HEIGHT);
	doHelp.hOffset=FRAME_WIDTH+(2.0*BUTTON_WIDTH)+(4.5*BUTTON_HEIGHT);
	doHelp.height=BUTTON_HEIGHT;
	doHelp.width=BUTTON_HEIGHT;
	doHelp.opacity=255;
	doHelp.alignButtonText();
	titleText.data="AMazer v"+widget.version+" ("+rows+"x"+columns+")";
	titleText.vOffset=FRAME_HEIGHT+(rows*mazeTileSize)+(BUTTON_HEIGHT*.75);
	titleText.hOffset=FRAME_WIDTH+(2.0*BUTTON_WIDTH)+(5*BUTTON_HEIGHT);

	if ( showToolTip ) {
		maze[mazeStartAddress.row][mazeStartAddress.column].tiles[3].tooltip="This is where you start";
		maze[mazeEndAddress.row][mazeEndAddress.column].tiles[3].tooltip="This is where you end";;
		mazeCursor.tooltip="This is where you are right now";
		doNewMaze.tooltip="Click me to generate a new maze";
		doSolution.tooltip="Click me to show the solution";
		doMoveLeft.tooltip="Click me to move left or use the left arrow key";
		doMoveUp.tooltip="Click me to move up or use the up arrow key";
		doMoveRight.tooltip="Click me to move right or use the right arrow key";
		doMoveDown.tooltip="Click me to move down or use the right arrow key";
		doHelp.tooltip="Click me to show or hide the help text";
	}
	mazeTraversed=new AddressList();
	mazeLastCell=null;
	maze[mazeStartAddress.row][mazeStartAddress.column].arriveCell();
	heartbeat.ticking="true";
	mainWindow.visible=true;
	
} // end initializeMaze()


function showOptimalTrack(){
	var cell=maze[mazeStartAddress.row][mazeStartAddress.column];
	while( cell.toOptimalMove!=null ){
		switch( cell.toOptimalMove ) {
			case LEFT:
				cell.isOptimal[0]=YES;
				cell.setOptimalImageSrc();
				cell=cell.toOptimalCell;
				cell.isOptimal[2]=YES;
				cell.setOptimalImageSrc();
				break;
			case UP:
				cell.isOptimal[1]=YES;
				cell.setOptimalImageSrc();
				cell=cell.toOptimalCell;
				cell.isOptimal[3]=YES;
				cell.setOptimalImageSrc();
				break;
			case RIGHT:
				cell.isOptimal[2]=YES;
				cell.setOptimalImageSrc();
				cell=cell.toOptimalCell;
				cell.isOptimal[0]=YES;
				cell.setOptimalImageSrc();
				break;
			case DOWN:
				cell.isOptimal[3]=YES;
				cell.setOptimalImageSrc();
				cell=cell.toOptimalCell;
				cell.isOptimal[1]=YES;
				cell.setOptimalImageSrc();
				break;
		}
	}
} // end showOptimalTrack

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														heartbeat
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function fHeartBeat(){
	if ( mazeCursor!=null ){
		if ( mazeCursor.opacity==0 ) {
			var fadein=new FadeAnimation( mazeCursor, 255, 50, animator.kEaseNone );
			animator.start( fadein );
		} else if ( mazeCursor.opacity==255 ) {
			var fadeout=new FadeAnimation( mazeCursor, 0, 500, animator.kEaseNone );	
			animator.start( fadeout );
		}
	}
}


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*														Main
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
mazeContextMenu=new Array();
mazeContextMenu[0]=new MenuItem();
mazeContextMenu[0].title="Help";
mazeContextMenu[0].checked=false;
mazeContextMenu[0].onSelect="toggleHelpText();"

var mazeWindow=new Frame();
mainWindow.appendChild( mazeWindow );
var doNewMaze=new Image(); mainWindow.appendChild( doNewMaze );
var doNewMazeText=new Text(); mainWindow.appendChild( doNewMazeText );
doNewMazeText.data="New Maze";
doNewMaze.src="Resources/Button100.png"
doNewMaze.onMouseDown="fDoNewMazeMouseDown();"
doNewMaze.onMouseUp="fDoNewMazeMouseUp();"
doNewMaze.hRegistrationPoint=doNewMaze.width/2;
doNewMaze.vRegistrationPoint=doNewMaze.height/2;
doNewMaze.setButtonText( doNewMazeText );
var doSolution=new Image(); mainWindow.appendChild( doSolution );
var doSolutionText=new Text(); mainWindow.appendChild( doSolutionText );
doSolutionText.data="Solve It";
doSolution.src="Resources/Button100.png"
doSolution.onMouseDown="fDoSolutionMouseDown();"
doSolution.onMouseUp="fDoSolutionMouseUp();"
doSolution.hRegistrationPoint=doSolution.width/2;
doSolution.vRegistrationPoint=doSolution.height/2;
doSolution.setButtonText( doSolutionText );
var doMoveLeft=new Image(); mainWindow.appendChild( doMoveLeft );
var doMoveLeftImage=new Image(); mainWindow.appendChild( doMoveLeftImage );
doMoveLeftImage.src="Resources/ArrowL.png";
doMoveLeft.src="Resources/Button28.png";
doMoveLeft.onMouseDown="fDoMoveLeftMouseDown();"
doMoveLeft.onMouseUp="fDoMoveLeftMouseUp();"
doMoveLeft.hRegistrationPoint=doMoveLeft.width/2;
doMoveLeft.vRegistrationPoint=doMoveLeft.height/2;
doMoveLeft.setButtonImage( doMoveLeftImage );
var doMoveUp=new Image(); mainWindow.appendChild( doMoveUp );
var doMoveUpImage=new Image(); mainWindow.appendChild( doMoveUpImage );
doMoveUpImage.src="Resources/ArrowU.png";
doMoveUp.src="Resources/Button28.png";
doMoveUp.onMouseDown="fDoMoveUpMouseDown();"
doMoveUp.onMouseUp="fDoMoveUpMouseUp();"
doMoveUp.hRegistrationPoint=doMoveUp.width/2;
doMoveUp.vRegistrationPoint=doMoveUp.height/2;
doMoveUp.setButtonImage( doMoveUpImage );
var doMoveRight=new Image(); mainWindow.appendChild( doMoveRight );
var doMoveRightImage=new Image(); mainWindow.appendChild( doMoveRightImage );
doMoveRightImage.src="Resources/ArrowR.png";
doMoveRight.src="Resources/Button28.png";
doMoveRight.onMouseDown="fDoMoveRightMouseDown();"
doMoveRight.onMouseUp="fDoMoveRightMouseUp();"
doMoveRight.hRegistrationPoint=doMoveRight.width/2;
doMoveRight.vRegistrationPoint=doMoveRight.height/2;
doMoveRight.setButtonImage( doMoveRightImage );
var doMoveDown=new Image(); mainWindow.appendChild( doMoveDown );
var doMoveDownImage=new Image(); mainWindow.appendChild( doMoveDownImage );
doMoveDownImage.src="Resources/ArrowD.png";
doMoveDown.src="Resources/Button28.png";
doMoveDown.onMouseDown="fDoMoveDownMouseDown();"
doMoveDown.onMouseUp="fDoMoveDownMouseUp();"
doMoveDown.hRegistrationPoint=doMoveDown.width/2;
doMoveDown.vRegistrationPoint=doMoveDown.height/2;
doMoveDown.setButtonImage( doMoveDownImage );
var doHelp=new Image(); mainWindow.appendChild( doHelp );
var doHelpText=new Text(); mainWindow.appendChild( doHelpText );
doHelpText.data="?";
doHelp.src="Resources/Button28.png"
doHelp.onMouseDown="fdoHelpMouseDown();"
doHelp.onMouseUp="fdoHelpMouseUp();"
doHelp.hRegistrationPoint=doHelp.width/2;
doHelp.vRegistrationPoint=doHelp.height/2;
doHelp.setButtonText( doHelpText );
var titleText=new Text();
titleText.data="AMazer";
titleText.style.fontFamily="sans-serif";;
titleText.style.fontSize="12px";
titleText.style.fontStyle="normal";
titleText.style.fontWeight="bold";
titleText.style.opacity=1;
mainWindow.appendChild( titleText );
mainWindow.contextMenuItems=mazeContextMenu;
mainWindow.onKeyDown="parseKeyPress()";

initializeMaze();

var helpText=new TextArea();
helpText.font="Arial";;
helpText.size=15;
helpText.style="bold";
helpText.editable=false;
helpText.hOffset=FRAME_WIDTH;
helpText.vOffset=FRAME_HEIGHT;
helpText.bgColor="#99FFFF";
helpText.bgOpacity=240;
helpText.color="#000000";
helpText.data=filesystem.readFile("AMazer.txt");
helpText.visible=false;
mainWindow.appendChild( helpText );